; Sample program for DOS-less diskette boot loader
; Embedded PC ISA Bus, Chapter 1
; Copyright 1997 Ed Nisley
; Assemble with Borland TASM

; Must be put on diskette with boot sector from BOOTSECT.BIN
; BOOTSECT must match the diskette's formatted size!

; Result:  Serial DTR (pin 20) blinks 1 second ON, 1 second OFF
; Use a serial breakout box to watch this happen...

              IDEAL
              MODEL     TINY

;--------------
; Set up a few constants

COMPORT       EQU       1                   ; which COM port to blink

BLINK_ON      EQU       15                  ; units of 64K microseconds
BLINK_OFF     EQU       15


;-------------
; Display output on serial port
; This is useful only if you've got an LED on the DTR line!
; We use the BIOS to meter out the blink rate for us

              CODESEG

              STARTUPCODE

              MOV       DX,0040h            ; aim at BIOS data segment
              MOV       ES,DX

              MOV       BX,2*(COMPORT-1)    ; which port address?
              MOV       DX,[ES:BX]          ; get COM port base address
              ADD       DX,4                ; set modem control port offset

              PUSH      DX                  ; prepare for loop


ReShow:
              POP       DX                  ; recover port
              PUSH      DX
              MOV       AL,1
              OUT       DX,AL               ; DTR goes low

              MOV       CX,BLINK_OFF        ; delay for a while
              MOV       DX,0
              MOV       AH,86h
              INT       15h

              POP       DX                  ; recover port
              PUSH      DX
              MOV       AL,0
              OUT       DX,AL               ; DTR goes high

              MOV       CX,BLINK_ON         ; delay for a while
              MOV       DX,0
              MOV       AH,86h
              INT       15h

              JMP       ReShow              ; continue forever

              END

