; Sample program for DOS-less diskette boot loader
; Assemble with Borland TASM

; Must be put on diskette with boot sector from BOOTSECT.BIN
; BOOTSECT must match the diskette's initial format size!

; Result:  Copies parallel port status input bits to data port

              IDEAL
              MODEL     TINY

;--------------
; Set up a few constants

LPTPORT       EQU       1                   ; which LPT port to blink

;--------------
; Pick up common files

              INCLUDE   "LPTDefs.inc"
              INCLUDE   "Macros.inc"

;-------------
; Display output on parallel port

              CODESEG

              STARTUPCODE

              MOV       DX,0040h            ; aim at BIOS data segment
              MOV       ES,DX

              MOV       BX,2*(LPTPORT-1)+0008h        ; aim at port entry
              MOV       DX,[ES:BX]          ; get LPT port base address


ReShow:
              INC       DX                  ; aim at status port
              IN        AL,DX               ; pick up status bits
              Punt                          ; allow bus recovery

              DEC       DX                  ; aim at data port
              OUT       DX,AL               ; send bits back out again

              JMP       ReShow              ; continue forever

              END

