; Sample program for DOS-less diskette boot loader
; Assemble with Borland TASM

; Must be put on diskette with boot sector from BOOTSECT.BIN
; BOOTSECT must match the diskette's initial format size!

; Result:  Parallel port displays counting sequence

              IDEAL
              MODEL     TINY

;--------------
; Set up a few constants

LPTPORT       EQU       1                   ; which LPT port to blink

;-------------
; Display output on parallel port
; This goes at the maximum bus rate, which is too fast to see

              CODESEG

              STARTUPCODE

              MOV       DX,0040h            ; aim at BIOS data segment
              MOV       ES,DX

              MOV       BX,2*(LPTPORT-1)+0008h        ; aim at port entry
              MOV       DX,[ES:BX]          ; get LPT port base address

              XOR       AL,AL               ; start from zero...

ReShow:
              INC       AL                  ; tick it
              OUT       DX,AL               ; send it out

              JMP       ReShow              ; continue forever

              END

