;--------------
; Define the parallel printer port status and control bits

              RECORD    Status {            ; port base + 1
                        PS_11_Inv:1         ; Busy       (inverted)
                        PS_10:1             ; -Ack, interrupt when low
                        PS_12:1             ; Paper
                        PS_13:1             ; Select
                        PS_15:1             ; -Error
                        PS_Unused:3
                        }

LPT_StatInv   EQU       (MASK PS_11_Inv)

              RECORD    Control {           ; port base + 2
                        PC_Unused:2
                        PC_BiDi:1           ; no pin, 1 = bidirectional
                        PC_IRQEnable:1      ; no pin, 1 = IRQ enabled
                        PC_17_Inv:1         ; -Select In (inverted)
                        PC_16:1             ; -Init
                        PC_14_Inv:1         ; -AutoLF    (inverted)
                        PC_1_Inv:1          ; -Strobe    (inverted)
                        }

LPT_CntlInv   EQU       (MASK PC_17_Inv OR MASK PC_14_Inv OR MASK PC_1_Inv)

