;--------------
; Handy macros

;-------------
; This is the Official Delay instruction required after each I/O operation
; Some clones don't need it, so some testing is in order
; The conditional allows you to remove or include it throughout a program

              MACRO     Punt
              LOCAL     Skipped

              IFDEF     IO_DELAY
              JMP       SHORT Skipped
Skipped:
              ENDIF

              ENDM


;-------------
; Pulse bit(s) in the I/O port selected by DX
; Outputs the current data, then flipping and restoring the bit

              MACRO     Blip    Accum,BitMask

              OUT       DX,Accum            ; send original data out
              Punt

              XOR       Accum,BitMask       ; flip the bit
              OUT       DX,Accum
              Punt

              XOR       Accum,BitMask       ; restore data
              OUT       DX,Accum
              Punt

              ENDM

