* Simple demo for DDS 8086 Developer's Kit
* Turn this into a HEX file with Dunfield's assembler:
*   ASM86 rotate.asm -fis w=130
*
* Load the MON86 monitor into the Embedded PC system using a diskette
*  boot loader from Chapter 1
* Then load rotate.hex using the L command
*  Your communications program must upload the HEX file as ASCII text
*   without waiting for character echos.
*  MON86 will display the total number of HEX data bytes loaded when
*   the transfer is complete.
*
* You can convert the HEX file to binary for direct booting from diskette:
*   HEXFMT rotate.hex -b w=rotate.bin
*
              ORG       $100
*
              MOV       DX,#$0378           Select parallel port
              MOV       AL,#$80             Set up the rotating bit
*
ReShow        ROL       AL,1                Rotate it
              OUT       DX,AL               And display it
*
              PUSH      DX                  Save our values
              PUSH      AX
*
              MOV       CX,#1               Use BIOS delay function
              MOV       DX,#0                ... to get 64K microseconds
              MOV       AH,#$86
              INT       $15
*
              POP       AX                  Recover our values
              POP       DX
*
              JMP       <ReShow
*
