/* Standard include file for 8086 programs                                   */

/*---------------------------------------------------------------------------*/
/* Galactic standard PC addresses and so forth                               */

#define I8259A    0x20                 /* primary interrupt controller       */
#define I8259B    0xA0                 /* secondary interrupt controller     */

#define I8259A_VECTOR   0x08           /* Primary controller base vector     */
#define I8259B_VECTOR   0x70           /*  ... ditto, secondary controller   */

#define NS_EOI    0x20                 /* non-specific End-Of-Interrupt      */

/*---------------------------------------------------------------------------*/
/* Handy stuff                                                               */

#define BYTE unsigned char
#define WORD unsigned int

#define TRUE 1
#define FALSE !TRUE


#define HI(x) (x >> 8)                 /* move high byte to low byte         */
#define LO(x) (x & 0x00FF)             /* isolate low byte                   */


/*--- useful character definitions                                           */
/*    these are in decimal so as to be useful in either C or assembler       */

#ifndef CANCEL

#define CANCEL    3
#define BELL      7
#define BS        8
#define TAB       9
#define CR        13
#define LF        10
#define FORMFEED  12
#define ESC       27
#define BLANK     ' '
#define DEL       127

#define XON       17
#define XOFF      19

#endif

#ifndef EOF
#define EOF -1
#endif

/*---------------------------------------------------------------------------*/
/* Assembler macros                                                          */

#define LOW(x) x
#define HIGH(x) =x

#define ASWORD(x) >x
#define ASBYTE(x) <x
