; Assemble with Borland TASM:
;   tasm /m /w1 /z

; Must be copied to diskette with boot sector from BOOTSECT.BIN
; BOOTSECT must match the diskette's initial format size!

; Requires '386 or higher CPU
; Blinks 55/AA on LPT data lines if this is not true...

; Sends counting sequence to parallel port
; Switches determine the output method
;   00 - simple programmed loop
;   01 - OUTSB in a loop
;   02 - REP OUTSB

              P386                          ; *** MUST HAVE '386 CPU!
              IDEAL
              MODEL     TINY

;--------------
; Set up a few constants

LPTPORT       EQU       1                   ; which LPT port to blink
IO_DELAY      EQU       1                   ; use I/O delay instruction

;--------------
; Pick up common definitions and macros

              INCLUDE   "LPTDefs.INC"
              INCLUDE   "Macros.INC"

;--------------
; Locate the data sequence buffer
; This does not appear in the COM file and fits within the 64K segment

              UDATASEG

BUFFSIZE      =         8000h

DataSeq       DB        BUFFSIZE DUP (?)


;-------------
; Display output on parallel port

              CODESEG

              STARTUPCODE

;--- do the setting-up exercises

              MOV       DX,0040h            ; aim at BIOS data segment
              MOV       ES,DX

              CALL      FindAddrs           ; set up port addresses

;--- verify that we have at least a 386

              CALL      FindCpuID
              CMP       AX,0300h
              JAE       GoodCPU

              MOV       AX,55AAh            ; we have a problem
              CALL      ShowError

GoodCPU:

;--- set up the data sequence

              MOV       CX,BUFFSIZE         ; count down to 0001
              MOV       DI,OFFSET DataSeq

FillBuff:
              MOV       [DI],CX
              INC       DI
              LOOP      FillBuff

;--- dump it to the port

ReShow:
              CALL      GetSwitches         ; decide which method we want

              MOV       CX,BUFFSIZE
              MOV       DX,[DataPort]
              MOV       SI,OFFSET DataSeq

              CMP       AL,00h
              JE        SimpleLoop
              CMP       AL,01h
              JE        OutSBLoop
              CMP       AL,02h
              JE        RepOutSB

SimpleLoop:                                 ; ordinary instructions
              MOV       AX,[SI]
              OUT       DX,AL
              INC       SI
              LOOP      SimpleLoop
              JMP       ReShow

OutSBLoop:                                  ; string output in loop
              OUTSB
              LOOP      OutSBLoop
              JMP       ReShow

RepOutSB:                                   ; REP string output
              REP OUTSB
              JMP       ReShow


;-------------
; Pick up common routines
; These could be assembled and linked separately,
;  but we're not doing gigantic programs here...

              INCLUDE   "Utils.ASM"

              END

