; Assemble with Borland TASM

; Must be put on diskette with boot sector from BOOTSECT.BIN
; BOOTSECT must match the diskette's initial format size!

; Pulse delays using LOOP as a short-delay timer
; Reads switches to get delay interval
; Sync scope on LPT data bit 0 to start timing
;  LPT data bit 1 blips at end of delay

              IDEAL
              MODEL     TINY

;--------------
; Set up a few constants

LPTPORT       EQU       1                   ; which LPT port to blink
IO_DELAY      EQU       1                   ; use I/O delay instruction

;--------------
; Pick up common definitions and macros

              INCLUDE   "LPTDefs.INC"
              INCLUDE   "Macros.INC"

;-------------
; Display output on parallel port

              CODESEG

              STARTUPCODE

;--- do the setting-up exercises

              MOV       DX,0040h            ; aim at BIOS data segment
              MOV       ES,DX

              CALL      FindAddrs           ; set up port addresses

;--- now read the switches and do the delay

ReShow:

              CALL      GetSwitches         ; fetch input bits
              MOV       CX,AX               ; set up for counting (AH=0)

              MOV       DX,[DataPort]       ; set up for display
              XOR       AL,AL               ; start with zero data

              Blip      AL,01h              ; starting sync

              JCXZ      NoDelay             ; compensate for zero delay
Delay:        LOOP      Delay               ; do the delay
NoDelay:

              Blip      AL,02h              ; ending sync

              JMP       ReShow              ; continue forever

;-------------
; Pick up common routines
; These could be assembled and linked separately,
;  but we're not doing gigantic programs here...

              INCLUDE   "Utils.ASM"

              END

