; Assemble with Borland TASM

; Must be put on diskette with boot sector from BOOTSECT.BIN
; BOOTSECT must match the diskette's initial format size!

; Display status/control inputs on LPT data port
;  Closed switches set the outputs HIGH and turn the LEDs ON
; Outputs are blipped at each update to allow scope timing
;  this means the LEDs are never completely off... see your scope!

              IDEAL
              MODEL     TINY

;--------------
; Set up a few constants

LPTPORT       EQU       1                   ; which LPT port to blink

;--------------
; Pick up common definitions and macros

              INCLUDE   "LPTDefs.INC"
              INCLUDE   "Macros.INC"

;-------------
; Display output on parallel port

              CODESEG

              STARTUPCODE

;--- do the setting-up exercises

              MOV       DX,0040h            ; aim at BIOS data segment
              MOV       ES,DX

              CALL      FindAddrs           ; set up port addresses

;--- now read the switches and display the results

ReShow:

              CALL      GetSwitches         ; fetch input bits

              MOV       DX,[DataPort]       ; display them
              NOT       AL                  ;  with a little blip first
              OUT       DX,AL
              Punt
              NOT       AL
              OUT       DX,AL

              JMP       ReShow              ; continue forever

;-------------
; Pick up common routines
; These could be assembled and linked separately,
;  but we're not doing gigantic programs here...

              INCLUDE   "Utils.ASM"

              END

