/* Tests new routines in FirmDev.ASM library file                            */
/* Requires PortIO.ASM and SerInit/SerIOFF.ASM library files                 */

/*---------------------------------------------------------------------------*/
/* Pick up standard definitions and constants                                */

#include <8086io.h>
#include "8086base.h"
#include "firmdev.h"



/*---------------------------------------------------------------------------*/
/* The new lib routines are SetAlarm and ByteToSegs                          */

main() {

WORD Alarm;                            /* high bit of low byte set by BIOS   */
unsigned int Counter;                  /* iteration counter                  */
WORD LEDBits;
WORD IntNum;
WORD Seg;
WORD SegSave;
WORD Off;
WORD OffSave;

   serinit(9600,1);
   enable();

   putstr("\nLibrary routine checkout\n");
   putstr("Embedded PC's ISA Bus Chapter 5 -- Ed Nisley\n");

   putstr("Get/Set Vector test...\n");
   IntNum = 0x50;                      /* probably unused...                 */
   GetVector(IntNum,&SegSave,&OffSave);
   printf("  Int %02x vector starts at %04x:%04x\n",IntNum,SegSave,OffSave);
   SetVector(IntNum,0x1234,0x5678);
   GetVector(IntNum,&Seg,&Off);
   printf("               changed to %04x:%04x\n",Seg,Off);
   SetVector(IntNum,SegSave,OffSave);
   GetVector(IntNum,&Seg,&Off);
   printf("              restored to %04x:%04x\n\n",SegSave,OffSave);

   putstr("LEDs should count up, LPT bit 0 toggles during waits...\n");

   Counter = 0;
   while (TRUE) {

      Alarm = 0;
      if (SetAlarm(0x0001,0x86A0,&Alarm)) {        /* alarm in 100 ms        */
         printf("Cannot use BIOS alarm function, code %02x\n",Alarm);
Stall:   goto Stall;
      }

      while (!Alarm) {                             /* wait for alarm         */
         outp(SYNC_ADDR,0x01);
         outp(SYNC_ADDR,0x00);
      }

      LEDBits = ByteToSegs(Counter);               /* convert the digits     */
      LEDBits |= (Counter & 0x0100) ? 0x0080 : 0x0000;      /* add two bits  */
      LEDBits |= (Counter & 0x0200) ? 0x8000 : 0x0000;      /* to the output */
      outpw(LED_ADDR,~LEDBits);

      ++Counter;

   }


}
