/* Firmware Development Board                                                */
/* Port addresses and bit locations                                          */

#define BOARD_BASE   0x0300            /* board starting address             */
#define BOARD_SIZE   0x0020            /* address range on board             */

#define NV_SEGMENT   0xC800            /* non-volatile memory base           */
#define NV_SIZE      0x1000            /*  ... and size                      */

#define SYNC_ADDR    0x0378            /* LPT port addr for scope syncs &c   */

#define I8254_BASE   (BOARD_BASE+0x0008)           /* base of timer regs     */
#define I8254_NS     139                           /* nanoseconds per count  */

/*--- LEDs and DIP switch inputs                                             */

#define LED_ADDR     (BOARD_BASE+0x001E)           /* offset of LED latches  */
#define SW_ADDR      (BOARD_BASE+0x001E)           /* offset of switch inputs*/


