/* Embedded PC's ISA Bus Chapter 6 -- Ed Nisley                              */
/* Micro-C program to scan for ROM BIOS extensions                           */
/* Assumes extensions do not cross segment boundaries!                       */

#include <8086io.h>
#include "8086base.h"

#define SHOWALL 0             /* 0 = show good blocks, 1 = show all blocks   */

/*---------------------------------------------------------------------------*/
/* The main event                                                            */

main() {

WORD BaseSeg;
WORD BaseOffset;
WORD TestAddr;
WORD BlockFlag;
WORD BlockSize;
BYTE CheckSum;

   serinit(9600,1);
   enable();

   putch(FORMFEED);
   putstr("ROM BIOS Extension Scan\n");
   putstr("Embedded PC's ISA Bus Chapter 6 -- Ed Nisley\n");

   putstr("Seg  Addr Flag Blks CSum\n");

   BaseSeg = 0xC000;
   BaseOffset = 0x0000;

   do {
      BlockFlag = peekw(BaseSeg,BaseOffset);
      BlockSize = peek(BaseSeg,BaseOffset+2);
      if ((0xAA55 == BlockFlag) || SHOWALL) {
         printf("%04x %04x %04x   %02x ",
                BaseSeg,BaseOffset,BlockFlag,BlockSize);
         if (0xAA55 == BlockFlag) {
            TestAddr = BaseOffset;
            CheckSum = 0;
            for (BlockSize *= 0x0200; BlockSize; --BlockSize) {
               CheckSum += peek(BaseSeg,TestAddr++);
            }
            printf("%02x OK!\n",CheckSum);
         }
         else {
            putstr("--\n");
         }
      }
      BaseOffset += 0x0200;
      if (!BaseOffset) {
         BaseSeg += 0x1000;
      }
   } while ((BaseSeg < 0xE000) ||
            ((BaseSeg == 0xE000) && !BaseOffset));

   putstr("\nDone (and spinning)...");
   while (TRUE) {
      continue;
   }

}
