/* Firmware Development Board                                                */
/* Port addresses and bit locations                                          */

#define BOARD_BASE   0x0300            /* board starting address             */
#define BOARD_BASE_A $0300
#define BOARD_SIZE   0x0020            /* address range on board             */

#define NV_SEGMENT   0xC800            /* non-volatile memory base           */
#define NV_SIZE      0x8000            /*  ... and size (32K = -32768!)      */

#define SYNC_ADDR    0x0378            /* LPT port addr for scope syncs &c   */

#define I8254_BASE   (BOARD_BASE+0x0008)           /* base of timer regs     */
#define I8254_NS     139                           /* nanoseconds per count  */

/*--- miscellaneous status and control bits                                  */

#define CTLS_ADDR    (BOARD_BASE+0x001C)           /* write also sets        */
#define CTLS_ADDR_A  $031c                         /*  fast watchdog mode    */
#define STAT_ADDR    (BOARD_BASE+0x001C)
#define STAT_ADDR_A  $031c

#define WATCHDOG     0x0100                        /* watchdog toggle output */
#define WATCHDOG_A   $0100
#define NV_WENABLE   0x0200                        /* 1 = enable NV writes   */
#define NV_WENABLE_A $0200

#define PWR_GOOD     0x0100                        /* 1 = power is still OK  */
#define PWR_GOOD_A   $0100

/*--- LEDs and DIP switch inputs                                             */

#define LED_ADDR     (BOARD_BASE+0x001E)           /* offset of LED latches  */
#define LED_ADDR_A   (BOARD_BASE_A+$001E)
#define SW_ADDR      (BOARD_BASE+0x001E)           /* offset of switch inputs*/
#define SW_ADDR_A    (BOARD_BASE_A+$001E)


