/*
//    A demonstration of the TDREM kernel using Borland C++
//    Embedded PC's ISA Bus Chapter 11 -- Ed Nisley
//    Displays iteration counter on Firmware Development Board LEDs
//     in raw binary, don't be surprised at the odd-looking patterns!
*/

#define  TRUE        1
#define  FALSE       0
#define  SIZE        30000

#include <dos.h>

char  flags[ SIZE + 1 ] ;


void     main(void)
{
   unsigned int   i, k, count, loops;

   loops = 0;

   /* Run the Sieve forever */
   for (;;)   {
      /* Perform the initialization */
      count = 0 ;
      for (i = 0; i <= SIZE; i++)
         flags[i] = TRUE ;

      /* Run the Sieve */
      for (i = 2; i <= SIZE; i++)   {

         if (flags[i])   {
            /* Cancel out all multiples of this prime */
            for (k = i + i; k <= SIZE; k += i)
               flags[k] = FALSE ;
            count++ ;

         }
      }
      outport(0x031e,~loops++);
   }
}
