; FirmDev.INC
; Useful constants for assembler routines


;-------------
; Fundamental addresses

BOARD_BASE    EQU       0300h               ; FDB base address
I8254_BASE    EQU       (BOARD_BASE+0008h)  ; timer base address

SYNCDDR       EQU       0378h               ; printer port for scope sync

;-------------
; Misc Control port output bits

CTLSDDR       EQU       (BOARD_BASE+001Ch)  ; control outputs

WATCHDOG      EQU       0100h               ; watchdog toggle output
NV_WENABLE    EQU       0200h               ; 1 = enable NV RAM writes
DS2400OUT     EQU       0400h               ; data to DS2400 serial number

LCD_E         EQU       1000h               ; char LCD E signal
LCD_RW        EQU       2000h               ;  ...     R/-W
LCD_RS        EQU       4000h               ;  ...     RS
LCD_NODRV     EQU       8000h               ;  ... 1 = disable data to LCD

;-------------
; Misc Status port inputs

STATDDR       EQU       (BOARD_BASE+001Ch)  ; status inputs

PWR_GOOD      EQU       0100h               ; 1 = power is OK
PUSHBUTTON    EQU       0200h               ; 0 = pushed
DS2400IN      EQU       0400h               ; data from DS2400 serial number

;-------------
; 2-digit LED display and switch inputs

LEDDDR        EQU       (BOARD_BASE+001Eh)
SWDDR         EQU       (BOARD_BASE+001Eh)

;-------------
; Graphic LCD Interface

GLCD_SEGMENT  EQU       0D000h              ; segment address
GLCD_LENGTH   EQU       08000h              ; memory size

GLCD_CTLS     EQU       (BOARD_BASE+001Ah)

GLCD_ENCTR    EQU       0001h               ; enable addr counters
GLCD_DISMUX   EQU       0002h               ; 1 disabled output mux
GLCD_ENDISP   EQU       0004h               ; enable LCD (if used)
GLCD_DISBLINK EQU       0080h               ; 1 disables blinking

GLCD_BLSLOW   EQU       0050h               ; slowest blinking
GLCD_BLMED    EQU       0040h               ; moderate blinking
GLCD_BLFAST   EQU       0030h               ; fastest blinking
GLCD_BLZERO   EQU       0000h               ; output logic zero
GLCD_BLCLOCK  EQU       0060h               ; output LCD clock
GLCD_BLONE    EQU       0070h               ; output logic one

GLCD_OFF      EQU       (GLCD_DISMUX OR GLCD_DISBLINK)
GLCD_ON       EQU       (GLCD_ENCTR OR GLCD_ENDISP)

