/* Character handling routines for the Graphic LCD Interface                 */

/*---------------------------------------------------------------------------*/
/* Globals                                                                   */

extern unsigned int NumFontChars;      /* number of chars in font table      */
extern int FontHeight;                 /* number of rows in each char        */
extern int FontWidth;                  /*  ... and columns                   */
extern int NumCharRows;                /* panel size in characters           */
extern int NumCharCols;


/*---------------------------------------------------------------------------*/
/* Prototypes                                                                */

void LCDInitFont(void);

void LCDWriteGlyph(int CharCode,int DotRow,int DotCol);

void LCDSetDotCursor(int DotRow,int DotCol);
void LCDGetDotCursor(int *pDotRow,int *pDotCol);

void LCDSetCharCursor(int Row,int Col);

int  LCDGetCharRow(void);
int  LCDGetCharCol(void);

void LCDHome(void);
void LCDClear(void);
void LCDSetBlink(int Blink);
void LCDSetVScroll(int Scroll);
void LCDSetHWrap(int Wrap);

void LCDSendChar(int CharCode);
void LCDSendString(char *pString);

