* Library routines to read and write I/O ports
* Firmware Furnace #33, Ed Nisley
* Micro-C now has similar routines: in, inw, out, outw
*  located in the standard library file inout.asm
*
* Read a BYTE port: int inp(address)
inp     MOV     BX,SP           Address stack
        MOV     DX,SS:2[BX]     Get address
        IN      AL,DX           Get value
        XOR     AH,AH           Zero high
        RET
*
* Read a WORD port: int inpw(address)
inpw    MOV     BX,SP           Address stack
        MOV     DX,SS:2[BX]     Get address
        IN      AX,DX           Get value
        RET
*
* Write a BYTE port: outp(address, data)
outp    MOV     BX,SP           Address stack
        MOV     DX,SS:4[BX]     Get address
        MOV     AX,SS:2[BX]     Get value
        OUT     DX,AL           Write data
        RET
*
* Write a WORD port: outpw(address, data)
outpw   MOV     BX,SP           Address stack
        MOV     DX,SS:4[BX]     Get address
        MOV     AX,SS:2[BX]     Get value
        OUT     DX,AX           Write data
        RET
